
randomMonicPolynomial=method(Options=>{Height=>20})
randomMonicPolynomial(ZZ,Ring) := opt -> (n,R) -> (
    kk:= coefficientRing R;
    x:= R_0;
    if char R >0 then x^n+sum(n,i->random(kk)*x^i) else (
	m := floor (opt.Height/2);
	x^n+sum(n,i->(random(ZZ,Height=>opt.Height)-m)*x^i))
    )

degreesOfFactors=method()
degreesOfFactors(RingElement) := f -> (
    L1 := toList factor f;
    L2 := apply(L1,a->first toList a);
    L3 := sort apply(L2,a->(degree a)_0);
    if L3_0==0 then L3=drop(L3,1) else L3
    )
    
randomPrimitivePolynomial=method(Options=>{Height=>20})
randomPrimitivePolynomial(ZZ,Ring) := opt-> (n,R) -> (
    assert(char R == 0);
    m := floor (opt.Height/2);
    x := R_0;
    cn := random(ZZ,Height=>m-1)+1;
    coeff := append(apply(n,i->random(ZZ,Height=>2*m)-m),cn);
    d:=gcd(coeff);
    if d>1 then coeff=apply(coeff,c->lift(c/d,ZZ));
    sum(n+1,i->coeff_i*x^i)
    )      

makeListOfPrimes = (startValue,lengthOfTheSequence) -> (
    primes:= {nextPrime startValue};
    while #primes < lengthOfTheSequence do (
	primes=append(primes, nextPrime(last primes+1))
	);
    primes)



end;

restart 
load("polynomialsOverFiniteFields.m2")
peek loadedFiles
primes=makeListOfPrimes(2,10)

p=nextPrime 10^2
kk=ZZ/p
R=kk[x]
f=randomMonicPolynomial(20,R)
degreesOfFactors f

elapsedTime L=apply(100,i-> degreesOfFactors randomMonicPolynomial(10,R))
tally L
L1=select(L,c->c_0==1)
#L1/#L+0.0


S=ZZ[x]
f1=randomPrimitivePolynomial(3,S,Height=>7)
f2=randomPrimitivePolynomial(3,S,Height=>7)
isPrime f2
isPrime f1
f=f1*f2

tally apply(primes, p-> (
	Sp= ZZ/p[gens S];
    	degreesOfFactors sub(f,Sp))    
)
f3=randomPrimitivePolynomial(6,S)
isPrime f3
factor f
tex f
tex f3
tally apply(primes, p-> (
	Sp= ZZ/p[gens S];
    	degreesOfFactors sub(f3,Sp))
)

use S
factor resultant(f3,diff(x,f3),x)
f3
viewHelp resultant

f=randomPrimitivePolynomial(5,S)
isPrime f
use S
factor resultant(f,diff(x,f),x)
primes=makeListOfPrimes(100,1000)
T=tally apply(primes, p-> (
	Sp= ZZ/p[gens S];
    	degreesOfFactors sub(f,Sp))
)

R=ZZ/nextPrime 10^4[x]
T'=tally apply(1000,i-> degreesOfFactors randomMonicPolynomial(5,R))
T',T








restart
p=nextPrime(10^3)
(p^12-p^6-p^4+p^2)/12

apply(10,i->(p=nextPrime(10^2+10*i);(p^12-p^6-p^4+p^2)/12))
apply(10,i->(p=nextPrime(10^2+10*i);(p^30-p^15-p^10-p^6+p^5+p^3+p^2-p)/30))

restart
R=QQ[p]
apply(5,i->(d=6^i;
(d,(p^(5)-p^(2)-p^1+1)/(6))
)
)
p=3, nextPrime(p+1)
d=6^3*3
netList apply(10,i->(p=nextPrime(p+1);(p,(p^d-p^(d/2)-p^(d/3)+p^(d/6))/d)))

restart
R=ZZ[x]
n=100
h=10
f=sum(n+1,i->(random(ZZ,Height=>2*h)-h)*x^i)
g=sum(n,i->(random(ZZ,Height=>2*h)-h)*x^i)
F=f
apply(floor(n),i->factor sub(f*g,x=>i))
f*g
factor f*g
 f= x^2+4*x+2
g=3*x^2-1
F=f*g
tex F
apply(-1..1,i->factor sub(f*g,x=>i))
apply(-1..1,i->factor sub(f,x=>i))
apply(-1..1,i->factor sub(g,x=>i))
primes={2}
for i from 1 to 1000 do primes=append(primes, nextPrime(last primes+1)) 
primes
T=tally apply(primes,p-> delete(0,apply(toList factor sub(F,ZZ/p[x]),f->(degree first f)_0)))
T1=select(keys T,t->min t==1)
sum(T1,k->T#k)

delete(13,primes)
viewHelp delete
